| Classic 16-bit LFSR (0xB400 generator).
| The generated noise is not that pretty, but the code is small.
|
| Lionel Debroux (TICT) 2010.
|
| This program is free software. It comes without any warranty, to
| the extent permitted by applicable law. You can redistribute it
| and/or modify it under the terms of the Do What The Fuck You Want
| To Public License, Version 2, as published by Sam Hocevar. See
| http://sam.zoy.org/wtfpl/COPYING for more details.

    .xdef    _ti89
    .xdef    _ti92plus
    .xdef    _v200
    .xdef    _nostub
    .text
    .even

    moveq   #0x26,%d0
    lsl.w   #4,%d0
    move.b  %d0,0x60000C
    trap    #1

    lea     0x4C00.w,%a1
    move.l  %a1,%d1
    move.w  #(3840/4)-1,%d0
save:
    move.l  (%a1)+,-(%sp)
    dbf     %d0,save

init:
    movea.l %d1,%a0
    neg.w   %d1
mainloop:
    move.b  %d0,0x60000E
    move.w  %d0,(%a0)+
    lsr.w   #1,%d0
    bcc.s   skip1
    eor.w   %d1,%d0
skip1: 
    cmpa.w  %a1,%a0
    bls.s   mainloop

    neg.w   %d1

| DIRTY
    movem.l %d0-%d1/%a1,-(%sp)
    pea     tict(%pc)
    pea     0x00480030.l
    movea.l 0xC8.w,%a0
    movea.l 4*0x1A9(%a0),%a0
    jsr     (%a0)
    addq.l  #8,%sp
    movem.l (%sp)+,%d0-%d1/%a1

    move.b  0x60001A,%d2
    lsr.b   #2,%d2
    bcs.s   init

    move.w  #(3840/4)-1,%d0
restore:
    move.l  (%sp)+,-(%a1)
    dbf     %d0,restore

    addq.w  #1,%d0
    trap    #1

    movea.l 0xC8.w,%a0
    movea.l 4*0x24C(%a0),%a0
    jmp     (%a0)

    .data
tict:
| Unfortunately, this binary data isn't executable code :'(
    .byte    'T','I','C','T',0
